#define MAIN_C

#include "interactif.h"
#include <stdlib.h> // exit Sun C++

int
main(int argc, char **argv)
{
  if ((argc == 2)&&!strcmp("-help",argv[1])) { help(); return 0; }
  try {
#if defined(mplib_pari)
    pari_init(3000000,2);
    signal(SIGINT,SIG_DFL);
    signal(SIGSEGV,SIG_DFL);
    signal(SIGBUS,SIG_DFL);
    {
#endif
    cin.tie(&cout); // Output is flushed when waiting for input.
    DESSIN d ((argc>1) ? argv[1] : "../DATA/b01");
    INTERACTIF f ("winname", d);
    f.loop ();
#if defined(mplib_pari)
    }
    freeall();
#endif
    return 0;
  }
  catch (exceptions a) {
    switch (a) {
      case invalid: cerr << "invalid catched\n"; break;
      case lecture: cerr << "lecture catched\n"; break;
    }
    return 2;
  }
  catch (...) {
    cerr << "EXCEPTION catched\n";
    return 16;
  }
}
